searchData={"items":[{"type":"module","title":"sidejob","doc":null,"ref":"sidejob.html"},{"type":"function","title":"sidejob.call/2","doc":"Same as call/3 with a default timeout of 5 seconds.","ref":"sidejob.html#call/2"},{"type":"function","title":"sidejob.call/3","doc":"Perform a synchronous call to the specified resource, failing if the resource has reached its usage limit.","ref":"sidejob.html#call/3"},{"type":"function","title":"sidejob.cast/2","doc":"Perform an asynchronous cast to the specified resource, failing if the resource has reached its usage limit.","ref":"sidejob.html#cast/2"},{"type":"function","title":"sidejob.new_resource/3","doc":"Same as new_resource/4 except that the number of workers defaults to the number of scheduler threads.","ref":"sidejob.html#new_resource/3"},{"type":"function","title":"sidejob.new_resource/4","doc":"Create a new sidejob resource that uses the provided worker module, enforces the requested usage limit, and is managed by the specified number of worker processes. This call will generate and load a new module, via sidejob_config , that provides information about the new resource. It will also start up the supervision hierarchy that manages this resource: ensuring that the workers and stats aggregation server for this resource remain running.","ref":"sidejob.html#new_resource/4"},{"type":"function","title":"sidejob.resource_exists/1","doc":"Check if the specified resource exists. Erlang docs call out that using erlang:module_exists should not be used, so try to call a function on the module in question and, if it succeeds, return true. Otherwise, the module hasn't been created so return false.","ref":"sidejob.html#resource_exists/1"},{"type":"function","title":"sidejob.unbounded_call/2","doc":"Same as unbounded_call/3 with a default timeout of 5 seconds.","ref":"sidejob.html#unbounded_call/2"},{"type":"function","title":"sidejob.unbounded_call/3","doc":"Perform a synchronous call, ignoring usage limites.","ref":"sidejob.html#unbounded_call/3"},{"type":"function","title":"sidejob.unbounded_cast/2","doc":"Perform an asynchronous cast to the specified resource, ignoring usage limits","ref":"sidejob.html#unbounded_cast/2"},{"type":"module","title":"sidejob_app","doc":null,"ref":"sidejob_app.html"},{"type":"function","title":"sidejob_app.config_change/3","doc":null,"ref":"sidejob_app.html#config_change/3"},{"type":"function","title":"sidejob_app.prep_stop/1","doc":null,"ref":"sidejob_app.html#prep_stop/1"},{"type":"function","title":"sidejob_app.start/2","doc":null,"ref":"sidejob_app.html#start/2"},{"type":"function","title":"sidejob_app.start_phase/3","doc":null,"ref":"sidejob_app.html#start_phase/3"},{"type":"function","title":"sidejob_app.stop/1","doc":null,"ref":"sidejob_app.html#stop/1"},{"type":"module","title":"sidejob_config","doc":"Utility that converts a given property list into a module that provides constant time access to the various key/value pairs. Example: load_config(test, [{limit, 1000}, {num_workers, 4}, {workers, [{test_1, test_2, test_3, test_4}]}]). creates the module test such that: test:limit(). =&gt; 1000 test:num_workers(). =&gt; 16 test:workers(). =&gt; [{test_1, test_2, test_3, test_4}]}]","ref":"sidejob_config.html"},{"type":"function","title":"sidejob_config.load_config/2","doc":null,"ref":"sidejob_config.html#load_config/2"},{"type":"module","title":"sidejob_resource_stats","doc":null,"ref":"sidejob_resource_stats.html"},{"type":"function","title":"sidejob_resource_stats.code_change/3","doc":null,"ref":"sidejob_resource_stats.html#code_change/3"},{"type":"function","title":"sidejob_resource_stats.handle_call/3","doc":null,"ref":"sidejob_resource_stats.html#handle_call/3"},{"type":"function","title":"sidejob_resource_stats.handle_cast/2","doc":null,"ref":"sidejob_resource_stats.html#handle_cast/2"},{"type":"function","title":"sidejob_resource_stats.handle_info/2","doc":null,"ref":"sidejob_resource_stats.html#handle_info/2"},{"type":"function","title":"sidejob_resource_stats.init/1","doc":null,"ref":"sidejob_resource_stats.html#init/1"},{"type":"function","title":"sidejob_resource_stats.init_stats/1","doc":"Used by sidejob_resource_sup to initialize a newly created stats ETS table to ensure the table is non-empty before bringing a resource online","ref":"sidejob_resource_stats.html#init_stats/1"},{"type":"function","title":"sidejob_resource_stats.reg_name/1","doc":null,"ref":"sidejob_resource_stats.html#reg_name/1"},{"type":"function","title":"sidejob_resource_stats.report/5","doc":"Used by sidejob_worker processes to report per-worker statistics","ref":"sidejob_resource_stats.html#report/5"},{"type":"function","title":"sidejob_resource_stats.start_link/2","doc":null,"ref":"sidejob_resource_stats.html#start_link/2"},{"type":"function","title":"sidejob_resource_stats.stats/1","doc":"Return the computed stats for the given sidejob resource","ref":"sidejob_resource_stats.html#stats/1"},{"type":"function","title":"sidejob_resource_stats.terminate/2","doc":null,"ref":"sidejob_resource_stats.html#terminate/2"},{"type":"function","title":"sidejob_resource_stats.usage/1","doc":"Return the current usage for the given sidejob resource","ref":"sidejob_resource_stats.html#usage/1"},{"type":"module","title":"sidejob_resource_sup","doc":"The sidejob_resource_sup manages the entire supervision hierarchy for a sidejob resource. Thus, there is one resource supervisor for each registered sidejob resource. The resource supervisor is the owner of a resource's limit and stats ETS tables, therefore ensuring the ETS tables survive crashes elsewhere in the resource hierarchy. The resource supervisor has two children: a sidejob_worker_sup that supervises the actual worker processes for a given resource, and a sidejob_resource_stats server that aggregates statistics reported by the worker processes.","ref":"sidejob_resource_sup.html"},{"type":"function","title":"sidejob_resource_sup.init/1","doc":null,"ref":"sidejob_resource_sup.html#init/1"},{"type":"function","title":"sidejob_resource_sup.start_link/2","doc":null,"ref":"sidejob_resource_sup.html#start_link/2"},{"type":"function","title":"sidejob_resource_sup.stats_ets/1","doc":null,"ref":"sidejob_resource_sup.html#stats_ets/1"},{"type":"module","title":"sidejob_stat","doc":null,"ref":"sidejob_stat.html"},{"type":"function","title":"sidejob_stat.add/4","doc":null,"ref":"sidejob_stat.html#add/4"},{"type":"function","title":"sidejob_stat.compute/1","doc":null,"ref":"sidejob_stat.html#compute/1"},{"type":"function","title":"sidejob_stat.new/0","doc":null,"ref":"sidejob_stat.html#new/0"},{"type":"module","title":"sidejob_sup","doc":"The top-level supervisor for the sidejob application. When a new resource is created via sidejob:new_resource/4 , a new sidejob_resource_sup is added to this supervisor. The actual resource supervisor manages a given resource's process hierarchy. This top-level supervisor simply ensures that all registered resource supervisors remain up.","ref":"sidejob_sup.html"},{"type":"function","title":"sidejob_sup.add_resource/2","doc":null,"ref":"sidejob_sup.html#add_resource/2"},{"type":"function","title":"sidejob_sup.init/1","doc":null,"ref":"sidejob_sup.html#init/1"},{"type":"function","title":"sidejob_sup.start_link/0","doc":null,"ref":"sidejob_sup.html#start_link/0"},{"type":"module","title":"sidejob_supervisor","doc":"This module implements a sidejob_worker behavior that operates as a parallel, capacity-limited supervisor of dynamic, transient children.","ref":"sidejob_supervisor.html"},{"type":"function","title":"sidejob_supervisor.code_change/3","doc":null,"ref":"sidejob_supervisor.html#code_change/3"},{"type":"function","title":"sidejob_supervisor.current_usage/1","doc":null,"ref":"sidejob_supervisor.html#current_usage/1"},{"type":"function","title":"sidejob_supervisor.handle_call/3","doc":null,"ref":"sidejob_supervisor.html#handle_call/3"},{"type":"function","title":"sidejob_supervisor.handle_cast/2","doc":null,"ref":"sidejob_supervisor.html#handle_cast/2"},{"type":"function","title":"sidejob_supervisor.handle_info/2","doc":null,"ref":"sidejob_supervisor.html#handle_info/2"},{"type":"function","title":"sidejob_supervisor.init/1","doc":null,"ref":"sidejob_supervisor.html#init/1"},{"type":"function","title":"sidejob_supervisor.rate/1","doc":null,"ref":"sidejob_supervisor.html#rate/1"},{"type":"function","title":"sidejob_supervisor.spawn/2","doc":null,"ref":"sidejob_supervisor.html#spawn/2"},{"type":"function","title":"sidejob_supervisor.spawn/4","doc":null,"ref":"sidejob_supervisor.html#spawn/4"},{"type":"function","title":"sidejob_supervisor.start_child/4","doc":null,"ref":"sidejob_supervisor.html#start_child/4"},{"type":"function","title":"sidejob_supervisor.terminate/2","doc":null,"ref":"sidejob_supervisor.html#terminate/2"},{"type":"function","title":"sidejob_supervisor.which_children/1","doc":null,"ref":"sidejob_supervisor.html#which_children/1"},{"type":"type","title":"sidejob_supervisor.resource/0","doc":null,"ref":"sidejob_supervisor.html#t:resource/0"},{"type":"module","title":"sidejob_worker","doc":"This module implements the sidejob_worker logic used by all worker processes created to manage a sidejob resource. This code emulates the gen_server API, wrapping a provided user-specified module which implements the gen_server behavior. The primary purpose of this module is updating the usage information published in a given resource's ETS table, such that capacity limiting operates correctly. The sidejob_worker also cooperates with a given sidejob_resource_stats server to maintain statistics about a given resource. By default, a sidejob_worker calculates resource usage based on message queue size. However, the user-specified module can also choose to implement the current_usage/1 and rate/1 callbacks to change how usage is calculated. An example is the sidejob_supervisor module which reports usage as: queue size + num_children.","ref":"sidejob_worker.html"},{"type":"function","title":"sidejob_worker.code_change/3","doc":null,"ref":"sidejob_worker.html#code_change/3"},{"type":"function","title":"sidejob_worker.handle_call/3","doc":null,"ref":"sidejob_worker.html#handle_call/3"},{"type":"function","title":"sidejob_worker.handle_cast/2","doc":null,"ref":"sidejob_worker.html#handle_cast/2"},{"type":"function","title":"sidejob_worker.handle_info/2","doc":null,"ref":"sidejob_worker.html#handle_info/2"},{"type":"function","title":"sidejob_worker.init/1","doc":null,"ref":"sidejob_worker.html#init/1"},{"type":"function","title":"sidejob_worker.reg_name/1","doc":null,"ref":"sidejob_worker.html#reg_name/1"},{"type":"function","title":"sidejob_worker.reg_name/2","doc":null,"ref":"sidejob_worker.html#reg_name/2"},{"type":"function","title":"sidejob_worker.start_link/6","doc":null,"ref":"sidejob_worker.html#start_link/6"},{"type":"function","title":"sidejob_worker.terminate/2","doc":null,"ref":"sidejob_worker.html#terminate/2"},{"type":"function","title":"sidejob_worker.workers/2","doc":null,"ref":"sidejob_worker.html#workers/2"},{"type":"module","title":"sidejob_worker_sup","doc":null,"ref":"sidejob_worker_sup.html"},{"type":"function","title":"sidejob_worker_sup.init/1","doc":null,"ref":"sidejob_worker_sup.html#init/1"},{"type":"function","title":"sidejob_worker_sup.start_link/4","doc":null,"ref":"sidejob_worker_sup.html#start_link/4"},{"type":"extras","title":"sidejob","doc":"sidejob\n=======\n\n![Test](https://github.com/erlangpack/sidejob/workflows/Test/badge.svg)\n[![Hex pm](http://img.shields.io/hexpm/v/sidejob.svg?style=flat)](https://hex.pm/packages/sidejob)\n\n(TODO: Write a better README. Current text is copied from [sidejob#1](https://github.com/basho/sidejob/pull/1))\n\nNote: this library was originally written to support process bounding in Riak using the sidejob_supervisor behavior. In Riak, this is used to limit the number of concurrent get/put FSMs that can be active, failing client requests with {error, overload} if the limit is ever hit. The purpose being to provide a fail-safe mechanism during extreme overload scenarios.\n\nsidejob is an Erlang library that implements a parallel, capacity-limited request pool. In sidejob, these pools are called resources. A resource is managed by multiple gen_server like processes which can be sent calls and casts using sidejob:call or sidejob:cast respectively.\n\nA resource has a fixed capacity. This capacity is split across all the workers, with each worker having a worker capacity of resource capacity/num_workers.\n\nWhen sending a call/cast, sidejob dispatches the request to an available worker, where available means the worker has not reached it's designated limit. Each worker maintains a usage count in a per-resource public ETS table. The process that tries to send a request will read/update slots in this table to determine available workers.\n\nThis entire approach is implemented in a scalable manner. When a process tries to send a sidejob request, sidejob determines the Erlang scheduler id the process is running on, and uses that to pick a certain worker in the worker pool to try and send a request to. If that worker is at it's limit, the next worker in order is selected until all workers have been tried. Since multiple concurrent processes in Erlang will be running on different schedulers, and therefore start at different offsets in the worker list, multiple concurrent requests can be attempted with little lock contention. Specifically, different processes will be touching different slots in the ETS table and hitting different ETS segment locks.\n\nFor a normal sidejob worker, the limit corresponds to the size of a worker's mailbox. Before sending a request to a worker the relevant usage value is incremented by the sender, after receiving the message the worker decrements the usage value. Thus, the total number of messages that can be sent to a set of sidejob workers is limited; in other words, a bounded process mailbox.\n\nHowever, sidejob workers can also implement custom usage strategies. For example, sidejob comes with the sidejob_supervisor worker that implements a parallel, capacity limited supervisor for dynamic, transient children. In this case, the capacity being managed is the number of spawned children. Trying to spawn additional results in the standard overload response from sidejob.\n\nIn addition to providing a capacity limit, the sidejob_supervisor behavior is more scalable than a single OTP supervisor when there multiple processes constantly attempting to start new children via said supervisor. This is because there are multiple parallel workers rather than a single gen_server process. For example, Riak moved away from using supervisors to manage it's get and put FSMs because the supervisor ended up being a bottleneck. Unfortunately, not using a supervisor made it hard to track the number of spawned children, return a list of child pids, etc. By moving to sidejob_supervisor for get/put FSM management, Riak can now how easily track FSM pids without the scalability problems -- in addition to having the ability to bound process growth.","ref":"readme.html"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS","ref":"license.html"}],"content_type":"text/plain","producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}